-- getch.e

-- function getch()  --returns integer (see below)
-- function getch2()  --returns sequence of integers {ascii,shift,ctrl,vk);
-- procedure BreakOff();

-- These functions use the win32 api--no interrupts.

-- getch() does not allow the keypress to show on the screen.
-- It returns the ascii value of the key if is an ascii key.
-- Non-ascii keys require using getch() twice.  The first return is zero,
-- the second is the scan code as if from interrupt 16h function 10h.

-- getch2() does not allow the keypress to show on the screen, either.
-- In its return sequence, ascii is zero for non-ascii keys, shift is a
-- flag for upper case, ctrl is a flag for the ctrl key state, and vk is
-- the win32 VK_ scan code.

-- If BreakOff() has been called, ctrl-c will be returned as ascii 3
-- and will not interrupt execution.  Ctrl-break will still halt as usual.
-- If BreakOff() is not called, ctrl-c is fatal.

include dll.e
include machine.e

atom gdll
integer g1, g2, b1

gdll = open_dll("getch.dll")

g1 = define_c_func(gdll,"_getch",{},C_INT)
g2 = define_c_func(gdll,"_getch2",{C_POINTER,C_POINTER,C_POINTER},C_INT)
b1 = define_c_proc(gdll,"_BreakOff",{})

global function getch()
  return c_func(g1, {})
  end function

global function getch2()
  integer char, shift, ctrl, vk
  atom pshift, pctrl, pvk
  sequence s
  pshift=allocate(4)
  pctrl=allocate(4)
  pvk=allocate(4)
  s={pshift,pctrl,pvk}
  char=c_func(g2,s)
  shift=peek4u(pshift)
  ctrl=peek4u(pctrl)
  vk=peek4u(pvk)
  free(pshift)
  free(pctrl)
  free(pvk)
  return {char, shift, ctrl, vk}
  end function

global procedure BreakOff()
  c_proc(b1,{})
  end procedure
